/*
 * SPDX-FileCopyrightText: 2018, 2019 Bruce Cowan <bruce@bcowan.me.uk>
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#include "config.h"
#include "mem.h"

#include <stdlib.h>

void *
check_calloc (size_t nmemb,
              size_t size)
{
  void *ptr = calloc (nmemb, size);
  if (!ptr)
    exit (EXIT_FAILURE);

  return ptr;
}

void *
check_malloc (size_t size)
{
  void *ptr = malloc (size);
  if (!ptr)
    exit (EXIT_FAILURE);

  return ptr;
}

void *
check_reallocarray (void   *ptr,
                    size_t  nmemb,
                    size_t  size)
{
#ifdef HAVE_REALLOCARRAY
  void *new = reallocarray (ptr, nmemb, size);
#else
  void *new = realloc (ptr, nmemb * size);
#endif

  if (!new)
    exit (EXIT_FAILURE);

  return new;
}
